#include <stdio.h>
#include <ctype.h>

/* Copyright (c) 1992 by Warren Toomey.		wkt@csadfa.cs.adfa.oz.au
 *
 * You may distribute this code for free (or a nominal copying fee) if you
 * do not alter the source code at all. If you want to distribute a changed
 * version, you should distribute a set of patches along with the original.
 *
 * You may not sell this source code or profit in any way from this code.
 */



#define STKSIZE 40

main(argc, argv)
  int argc;
  char *argv[];
{
  int ch;
  int ND = 0;
  int num = 0;
  int state = 0;
  int z = 0;
  char stk[STKSIZE];

  switch (argc)
  {
    case 1:
      break;
    case 2:
      if (freopen(argv[1], "r", stdin) == NULL)
      {
	fprintf(stderr, "Could not open %s\n", argv[1]);
	exit(1);
      }
      break;
    default:
      fprintf(stderr, "Usage: pfb2pfe [pfbfile]\n");
      exit(1);
  }

  while ((ch = getchar()) != EOF)
  {
   if (ch=='\r') ch='\n';

/*
 * I knew the 3rd year compiler course I did would come in handy one day!!
 *
 * We grep for number -!, number chars after that is 
 * handled by parsecharstring.
 */

    switch (state)
    {
      case 0:
	if (isdigit(ch))
	{
      firstdigit:
	  num = ch - '0';
	  goto pushchar;	/* Yuk, a goto */
	}
	putchar(ch);
	break;
      case 1:
	if (ch == ' ')
	  goto pushchar;	/* Yuk, a goto */
	if (isdigit(ch))
	{
	  num = 10 * num + ch - '0';
	  state--;
	  goto pushchar;	/* Yuk, a goto */
	}
	goto killstack;		/* Yuk, a goto */
      case 2:
	if (ch != '-')
	  goto killstack;	/* Yuk, a goto */
    pushchar:
	state++;
	stk[z++] = ch;
	if (z==STKSIZE)		/* Heuristic - we've hit the 00000 at the */
	 exit(0);		/* bottom of the file */
	break;
      case 3:
	if (ch == '!')
	{
	  state++;
	  break;
	}
    killstack:
	for (num = 0; num < z; num++)
	  putchar(stk[num]);
	z = state = num = 0;
	if (isdigit(ch))
	  goto firstdigit;	/* Yuk, a goto */
	else
	  putchar(ch);
	break;

/* State 4 is where we decode the encrypted
 * commands and numbers
 */

      case 4:
	parsecharstring(num);
	getchar();
	getchar();		/* Ignore the 3-char trailer */
	getchar();
	z = state = 0;
    }
  }
}

static char *cmdlist[32] = {
  "NULL",
  "hstem",
  "NULL",
  "vstem",
  "vmoveto",
  "rlineto",
  "hlineto",
  "vlineto",
  "rrcurveto",
  "closepath",
  "callsubr",
  "return",
  "ESCAPE",
  "hsbw",
  "endchar",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "rmoveto",
  "hmoveto",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "NULL",
  "vhcurveto",
  "hvcurveto"
};

unsigned short int getgetbuffer;

int 
Getgetchar()
{
  int c;
  char inbuf[3];
  unsigned int out;

  inbuf[2]='\0';
  inbuf[0]= getchar();
  if (inbuf[0]=='\n') inbuf[0]=getchar();
  inbuf[1]= getchar();
  if (inbuf[1]=='\n') inbuf[1]=getchar();
  sscanf(inbuf,"%2x", &c);
  out = c ^ (getgetbuffer >> 8);
  getgetbuffer = (unsigned short)((long)(c + getgetbuffer) * 0xce6dL + 0x58bfL);
  return out;
}

int 
parsecharstring(n)
{
  int c;
  int w;

  getgetbuffer = 4330;
  Getgetchar();
  Getgetchar();			/* Ignore 4 random byte header */
  Getgetchar();
  Getgetchar();
  n -= 4;

/* Now determine what the input bytes mean
 */
  while (n > 0)
  {
    c = Getgetchar();
    if (c > 31)			/* It's an integer */
    {
      if (c == 255)
      {
	c = (Getgetchar() << 24);
	c += (Getgetchar() << 16);
	c += (Getgetchar() << 8);
	c += Getgetchar();
	printf("%d ", c);
	n -= 5;
      }
      else if (c > 250)
      {
	w = Getgetchar();
	c = 256 * (c - 251) + w + 108;
	c = -c;
	printf("%d ", c);
	n -= 2;
      }
      else if (c > 246)
      {
	w = Getgetchar();
	c = 256 * (c - 247) + w + 108;
	printf("%d ", c);
	n -= 2;
      }
      else
      {
	printf("%d ", c - 139);
	n--;
      }
    }
    else
    {				/* It's a command */
      if (c != 12)
      {
	n--;
	printf("%s\n", cmdlist[c]);
      }
      else
      {
	n -= 2;
	switch (Getgetchar())
	{
	  case 0:
	    printf("dotsection\n");
	    break;
	  case 1:
	    printf("vstem3\n");
	    break;
	  case 2:
	    printf("hstem3\n");
	    break;
	  case 6:
	    printf("seac\n");
	    break;
	  case 7:
	    printf("sbw\n");
	    break;
	  case 12:
	    printf("div\n");
	    break;
	  case 16:
	    printf("callothersub\n");
	    break;
	  case 17:
	    printf("pop\n");
	    break;
	  case 33:
	    printf("setcurrentpoint\n");
	    break;
	}
      }
    }
  }
}
